#pragma once
#include "precompile.h"
#include "tcp_client.h"
#include "shell_process.h"
#include "directory.h"
#include "process.h"


/// <summary>
/// Container class fr att f tcp_clienten att alltid frska ansluta nr den frlorar sin anslutning, detta grs via disconnect_function som om initializerar tcp_clienten och anluter igen
/// </summary>
class client
{
public:
	client(std::string ip, int port);
	~client() {
		shell.~shell_process();
	}
	/// <summary>
	/// Garanterar att anslutning lyckas slutligen.
	/// Frsker att teransluta till anslutningen r etablerad 
	/// </summary>
	void connect();

	/// <summary>
	/// Starta paket_loop
	/// </summary>
	void run_packet_handler() { client_implementation.paket_loop(); }

private:

	std::string ip_; // anslutnigs ip
	int port_; // anslutnings port

	tcp_client client_implementation; // client instans som ominitializeras nr den frlorar anslutning

	response_table get_responses();
	action_table get_actions();

	response_table responses_ = get_responses(); // tabell fr att hantera packet som krver en simpel respons

	action_table actions_ = get_actions(); // tabell fr att hantera packet som krver ingen eller mer n en respons

	shell_process shell;

	/// <summary>
	/// Funktionen kallas nr klienten anslutnings avbryts och nr den ska skapas
	/// </summary>
	void startup();

};

