#pragma once
#include "precompile.h"
#include "window_log.h"

using func_map = std::unordered_map<std::string, std::function<void(std::string)>>; // alias fr en map/dictionary med nyckeln string och datan en funktion som returnerar void men tar emot en strng som parameter
//anvnds fr att skapa en konsol i en viss del av skrmen 
//rver frn window_log fr att kunna skapa en log p en viss position av skrmen och fr att en konsol r en typ av window_log
class command_line :
	public window_log
{
public:
	command_line(window&, point, size, std::string, func_map); // skapa konsolen med ett frldrar fnster, position, storlek, prompt-meddelande och en funktions map
	void prompt(); // fr att acceptera ett kommando och exekevera om den finns i funk mappen
	bool alive(); // fr att bryta loopen vid tex shutdown 
	void set_prompt(std::string prompt) { prompt_ = prompt; } // set funktion
	void set_functions(func_map fm) { functions_ = fm; } // set funktion
	std::string input_str(bool print_input); // fr att ta emot input: tex cin << s; -> input_str(2);
	void d();
private:
	std::string prompt_; // prompt-meddelande
	func_map functions_; // map av funktioner
	bool alive_; // fr att upperthlla en loop
	std::string input(int y); // fr att ta input vid en specifik y koordinat
	std::vector<std::string> argument_parser(std::string); // parsa strng efter mellanslag fr att seperera argument
	bool map_exist_execute(func_map, std::string, std::string);
	std::pair<std::string, std::string> split_input(std::string); // splita input mellan frsta ' '
};