#include "precompile.h"
#include "input_box.h"

input_box::input_box(window& win, point position, int length) : ui_element(win, position), length_{ length }{}

void input_box::edit() // fr att ndra input
{
	int key = 0;
	int count = content_.length();
	while (key != 13) { // medans man inte har tryckt enter
		key = getch(); // ta in ny tangent
		if (key >= 32 and key <= 126 and count < length_) { // om man har tyckt en karaktr och man inte har skrivit fr lngt
			content_ += key; // lgg till i buffern
			mvwprintw(window_.get_window(), position_.y, position_.x + count, std::string(1, key).c_str()); // skriv ut karaktren
			++count; // uppdatera rknare
		}
		else if ((key == 127 or key == '\b' or key == KEY_BACKSPACE) && count > 0) { // om tangenten r backspace och count r strre n noll
			mvwprintw(window_.get_window(), position_.y, position_.x + count - 1, " "); // skriv ut mellanslag dr karaktren var
			content_.erase(count - 1, 1); // ta bort frn buffern
			--count; // uppdatera rknare
		}
		// uppdatera skrm
		refresh(); 
		wrefresh(window_.get_window());
	}
}

void input_box::set_length(int length)
{
	length_ = length;
}

int input_box::get_length()
{
	return length_;
}

size input_box::get_element_size() const
{
	return size{ length_, 1 }; // max lngden som fr skrivas och en rad i storlek
}

void input_box::draw_element()
{
	mvwprintw(window_.get_window(), position_.y, position_.x, content_.c_str()); // skriv ut vad som r i content_ buffern
}
