#pragma once
#include "precompile.h"

//struktur fr att kunna hantera en klient
struct client {
	int socket_id{ 0 }; // idet p socketen som klienten har
	std::string ip_address; // ipaddressen p klienten
	std::string name; // pseudo namnet p klienten

	std::unordered_map<std::string, std::unordered_map<std::string, std::string>> information{
		{"computer", { // hrd och mjukvaru information om klienten
			{"Windows Product",""},
			{"Windows Owner",""},
			{"Windows Architecture",""},
			{"Computer Name",""},
			{"Cpu Name", ""},
			{"Ram Size",""},
			{"Windows Username",""},
			{"Running As Admin", ""}
		}},
		
		{"location", { // platsbaserad information om klienten
			{"Public Ip", ""},
			{"Continent", ""},
			{"Country", ""},
			{"Region", ""},
			{"City", ""},
			{"Latitude", ""},
			{"Longitude", ""},
			{"Language", ""}
		}}

	};

	bool operator==(const client& that) const { // vid jmnfrelse av olika klienter
		return
			ip_address == that.ip_address &&
			socket_id == that.socket_id &&
			name == that.name;
	}

	std::string to_string() {
		return "[ id: " + std::to_string(socket_id ) + ", ip: " + ip_address + ", name: " + name + " ]";
	}
};

inline std::ostream& operator<<(std::ostream& os, const client& m) // vid utskrift av klient
{
	return os << "[" << m.socket_id << "|" << m.ip_address << "|" << m.name << "]";
}
// struktur vid hmtning av pseudo "tcp" huvudet
struct header {
	int id_size;
	int data_size;
};
//struktur vid hmtning av ett paket
struct packet {
	std::string id;
	std::string data;
	client* owner;

	bool operator==(const packet& that) const { // vid jmnfrelse av olika paket
		return
			id == that.id &&
			data == that.data &&
			*owner == *that.owner;
	}

	std::string to_string() {
		return "[" + id + "|" + data.substr(0, 10) + "]\n";
	}
};

// struktur vid skickning av en data eller ett meddelande
struct message {
	std::string identifier;
	std::string data;

	std::string buffer() { // anvnt fr att seriliza message strukturten till en strng fr att kunna verfra den via send
		std::stringstream ss; // ett problem med stringstream r att den tar hnsyn till locale
		// detta gr att nr man skriver ra siffror till streamen s bli dem formaterade med komma 1000 -> 1,000
		// detta pajar grejen med serialazation
		// fr att undvika detta s har jag valt att konvertera till strng innan man skriver till streamen
		ss
			<< std::string(16 - std::to_string(identifier.length()).length(), '0') << std::to_string(identifier.length())
			<< std::string(16 - std::to_string(data.length()).length(), '0') << std::to_string(data.length())
			<< identifier
			<< data;

		return ss.str();
	}
};